diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.4.pl ./wordpress-3.3.2/wp-includes/post.php ./wordpress-3.4/wp-includes/post.php
*** ./wordpress-3.3.2/wp-includes/post.php	2011-11-23 18:20:21.000000000 -0600
--- ./wordpress-3.4/wp-includes/post.php	2012-05-13 02:41:47.000000000 -0500
***************
*** 29,34 ****
--- 29,35 ----
  		'hierarchical' => false,
  		'rewrite' => false,
  		'query_var' => false,
+ 		'delete_with_user' => true,
  		'supports' => array( 'title', 'editor', 'author', 'thumbnail', 'excerpt', 'trackbacks', 'custom-fields', 'comments', 'revisions', 'post-formats' ),
  	) );
  
***************
*** 45,50 ****
--- 46,52 ----
  		'hierarchical' => true,
  		'rewrite' => false,
  		'query_var' => false,
+ 		'delete_with_user' => true,
  		'supports' => array( 'title', 'editor', 'author', 'thumbnail', 'page-attributes', 'custom-fields', 'comments', 'revisions' ),
  	) );
  
***************
*** 63,69 ****
  		'rewrite' => false,
  		'query_var' => false,
  		'show_in_nav_menus' => false,
! 		'supports' => array( 'comments' ),
  	) );
  
  	register_post_type( 'revision', array(
--- 65,72 ----
  		'rewrite' => false,
  		'query_var' => false,
  		'show_in_nav_menus' => false,
! 		'delete_with_user' => true,
! 		'supports' => array( 'comments', 'author' ),
  	) );
  
  	register_post_type( 'revision', array(
***************
*** 80,85 ****
--- 83,90 ----
  		'rewrite' => false,
  		'query_var' => false,
  		'can_export' => false,
+ 		'delete_with_user' => true,
+ 		'supports' => array( 'author' ),
  	) );
  
  	register_post_type( 'nav_menu_item', array(
***************
*** 91,96 ****
--- 96,102 ----
  		'_builtin' => true, /* internal use only. don't use this when registering your own post type. */
  		'hierarchical' => false,
  		'rewrite' => false,
+ 		'delete_with_user' => false,
  		'query_var' => false,
  	) );
  
***************
*** 168,179 ****
   *
   * @param int $attachment_id Attachment ID.
   * @param bool $unfiltered Whether to apply filters.
!  * @return string The file path to the attached file.
   */
  function get_attached_file( $attachment_id, $unfiltered = false ) {
  	$file = get_post_meta( $attachment_id, '_wp_attached_file', true );
  	// If the file is relative, prepend upload dir
! 	if ( 0 !== strpos($file, '/') && !preg_match('|^.:\\\|', $file) && ( ($uploads = wp_upload_dir()) && false === $uploads['error'] ) )
  		$file = $uploads['basedir'] . "/$file";
  	if ( $unfiltered )
  		return $file;
--- 174,185 ----
   *
   * @param int $attachment_id Attachment ID.
   * @param bool $unfiltered Whether to apply filters.
!  * @return string|bool The file path to the attached file, or false if the attachment does not exist.
   */
  function get_attached_file( $attachment_id, $unfiltered = false ) {
  	$file = get_post_meta( $attachment_id, '_wp_attached_file', true );
  	// If the file is relative, prepend upload dir
! 	if ( $file && 0 !== strpos($file, '/') && !preg_match('|^.:\\\|', $file) && ( ($uploads = wp_upload_dir()) && false === $uploads['error'] ) )
  		$file = $uploads['basedir'] . "/$file";
  	if ( $unfiltered )
  		return $file;
***************
*** 328,356 ****
   * 'more'. There can be text or space(s) after the word 'more', but won't be
   * referenced.
   *
!  * The returned array has 'main' and 'extended' keys. Main has the text before
   * the <code><!--more--></code>. The 'extended' key has the content after the
!  * <code><!--more--></code> comment.
   *
   * @since 1.0.0
   *
   * @param string $post Post content.
!  * @return array Post before ('main') and after ('extended').
   */
  function get_extended($post) {
  	//Match the new style more links
  	if ( preg_match('/<!--more(.*?)?-->/', $post, $matches) ) {
  		list($main, $extended) = explode($matches[0], $post, 2);
  	} else {
  		$main = $post;
  		$extended = '';
  	}
  
  	// Strip leading and trailing whitespace
  	$main = preg_replace('/^[\s]*(.*)[\s]*$/', '\\1', $main);
  	$extended = preg_replace('/^[\s]*(.*)[\s]*$/', '\\1', $extended);
  
! 	return array('main' => $main, 'extended' => $extended);
  }
  
  /**
--- 334,365 ----
   * 'more'. There can be text or space(s) after the word 'more', but won't be
   * referenced.
   *
!  * The returned array has 'main', 'extended', and 'more_text' keys. Main has the text before
   * the <code><!--more--></code>. The 'extended' key has the content after the
!  * <code><!--more--></code> comment. The 'more_text' key has the custom "Read More" text.
   *
   * @since 1.0.0
   *
   * @param string $post Post content.
!  * @return array Post before ('main'), after ('extended'), and custom readmore ('more_text').
   */
  function get_extended($post) {
  	//Match the new style more links
  	if ( preg_match('/<!--more(.*?)?-->/', $post, $matches) ) {
  		list($main, $extended) = explode($matches[0], $post, 2);
+ 		$more_text = $matches[1];
  	} else {
  		$main = $post;
  		$extended = '';
+ 		$more_text = '';
  	}
  
  	// Strip leading and trailing whitespace
  	$main = preg_replace('/^[\s]*(.*)[\s]*$/', '\\1', $main);
  	$extended = preg_replace('/^[\s]*(.*)[\s]*$/', '\\1', $extended);
+ 	$more_text = preg_replace('/^[\s]*(.*)[\s]*$/', '\\1', $more_text);
  
! 	return array( 'main' => $main, 'extended' => $extended, 'more_text' => $more_text );
  }
  
  /**
***************
*** 427,433 ****
  function get_post_ancestors($post) {
  	$post = get_post($post);
  
! 	if ( !empty($post->ancestors) )
  		return $post->ancestors;
  
  	return array();
--- 436,445 ----
  function get_post_ancestors($post) {
  	$post = get_post($post);
  
! 	if ( ! isset( $post->ancestors ) )
! 		_get_post_ancestors( $post );
! 
! 	if ( ! empty( $post->ancestors ) )
  		return $post->ancestors;
  
  	return array();
***************
*** 493,499 ****
   *
   * @param int|object $post A post
   *
!  * @return mixed The format if successful. False if no format is set.  WP_Error if errors.
   */
  function get_post_format( $post = null ) {
  	$post = get_post($post);
--- 505,511 ----
   *
   * @param int|object $post A post
   *
!  * @return mixed The format if successful. False if no format is set. WP_Error if errors.
   */
  function get_post_format( $post = null ) {
  	$post = get_post($post);
***************
*** 531,537 ****
   * @since 3.1.0
   *
   * @param int|object $post The post for which to assign a format
!  * @param string $format  A format to assign.  Use an empty string or array to remove all formats from the post.
   * @return mixed WP_Error on error. Array of affected term IDs on success.
   */
  function set_post_format( $post, $format ) {
--- 543,549 ----
   * @since 3.1.0
   *
   * @param int|object $post The post for which to assign a format
!  * @param string $format  A format to assign. Use an empty string or array to remove all formats from the post.
   * @return mixed WP_Error on error. Array of affected term IDs on success.
   */
  function set_post_format( $post, $format ) {
***************
*** 626,632 ****
  }
  
  /**
!  * Register a post type. Do not use before init.
   *
   * A simple function for creating or modifying a post status based on the
   * parameters given. The function will accept an array (second optional
--- 638,644 ----
  }
  
  /**
!  * Register a post status. Do not use before init.
   *
   * A simple function for creating or modifying a post status based on the
   * parameters given. The function will accept an array (second optional
***************
*** 743,749 ****
   * @param string $output The type of output to return, either post status 'names' or 'objects'. 'names' is the default.
   * @param string $operator The logical operation to perform. 'or' means only one element
   *  from the array needs to match; 'and' means all elements must match. The default is 'and'.
!  * @return array A list of post type names or objects
   */
  function get_post_stati( $args = array(), $output = 'names', $operator = 'and' ) {
  	global $wp_post_statuses;
--- 755,761 ----
   * @param string $output The type of output to return, either post status 'names' or 'objects'. 'names' is the default.
   * @param string $operator The logical operation to perform. 'or' means only one element
   *  from the array needs to match; 'and' means all elements must match. The default is 'and'.
!  * @return array A list of post status names or objects
   */
  function get_post_stati( $args = array(), $output = 'names', $operator = 'and' ) {
  	global $wp_post_statuses;
***************
*** 864,916 ****
   * Optional $args contents:
   *
   * - label - Name of the post type shown in the menu. Usually plural. If not set, labels['name'] will be used.
   * - description - A short descriptive summary of what the post type is. Defaults to blank.
!  * - public - Whether posts of this type should be shown in the admin UI. Defaults to false.
!  * - exclude_from_search - Whether to exclude posts with this post type from search results.
!  *     Defaults to true if the type is not public, false if the type is public.
!  * - publicly_queryable - Whether post_type queries can be performed from the front page.
!  *     Defaults to whatever public is set as.
!  * - show_ui - Whether to generate a default UI for managing this post type. Defaults to true
!  *     if the type is public, false if the type is not public.
!  * - show_in_menu - Where to show the post type in the admin menu. True for a top level menu,
!  *     false for no menu, or can be a top level page like 'tools.php' or 'edit.php?post_type=page'.
!  *     show_ui must be true.
!  * - menu_position - The position in the menu order the post type should appear. Defaults to the bottom.
   * - menu_icon - The url to the icon to be used for this menu. Defaults to use the posts icon.
   * - capability_type - The string to use to build the read, edit, and delete capabilities. Defaults to 'post'.
!  *   May be passed as an array to allow for alternative plurals when using this argument as a base to construct the
!  *   capabilities, e.g. array('story', 'stories').
!  * - capabilities - Array of capabilities for this post type. By default the capability_type is used
!  *      as a base to construct capabilities. You can see accepted values in {@link get_post_type_capabilities()}.
   * - map_meta_cap - Whether to use the internal default meta capability handling. Defaults to false.
!  * - hierarchical - Whether the post type is hierarchical. Defaults to false.
!  * - supports - An alias for calling add_post_type_support() directly. See {@link add_post_type_support()}
!  *     for documentation. Defaults to none.
   * - register_meta_box_cb - Provide a callback function that will be called when setting up the
!  *     meta boxes for the edit form.  Do remove_meta_box() and add_meta_box() calls in the callback.
   * - taxonomies - An array of taxonomy identifiers that will be registered for the post type.
!  *     Default is no taxonomies. Taxonomies can be registered later with register_taxonomy() or
!  *     register_taxonomy_for_object_type().
!  * - labels - An array of labels for this post type. By default post labels are used for non-hierarchical
!  *     types and page labels for hierarchical ones. You can see accepted values in {@link get_post_type_labels()}.
!  * - permalink_epmask - The default rewrite endpoint bitmasks.
!  * - has_archive - True to enable post type archives. Will generate the proper rewrite rules if rewrite is enabled.
!  * - rewrite - false to prevent rewrite. Defaults to true. Use array('slug'=>$slug) to customize permastruct;
!  *     default will use $post_type as slug. Other options include 'with_front', 'feeds', and 'pages'.
!  * - query_var - false to prevent queries, or string to value of the query var to use for this post type
!  * - can_export - true allows this post type to be exported.
!  * - show_in_nav_menus - true makes this post type available for selection in navigation menus.
   * - _builtin - true if this post type is a native or "built-in" post_type. THIS IS FOR INTERNAL USE ONLY!
   * - _edit_link - URL segement to use for edit link of this post type. THIS IS FOR INTERNAL USE ONLY!
   *
   * @since 2.9.0
   * @uses $wp_post_types Inserts new post type object into the list
   *
!  * @param string $post_type Name of the post type.
!  * @param array|string $args See above description.
   * @return object|WP_Error the registered post type object, or an error object
   */
! function register_post_type($post_type, $args = array()) {
  	global $wp_post_types, $wp_rewrite, $wp;
  
  	if ( !is_array($wp_post_types) )
--- 876,959 ----
   * Optional $args contents:
   *
   * - label - Name of the post type shown in the menu. Usually plural. If not set, labels['name'] will be used.
+  * - labels - An array of labels for this post type.
+  *     * If not set, post labels are inherited for non-hierarchical types and page labels for hierarchical ones.
+  *     * You can see accepted values in {@link get_post_type_labels()}.
   * - description - A short descriptive summary of what the post type is. Defaults to blank.
!  * - public - Whether a post type is intended for use publicly either via the admin interface or by front-end users.
!  *     * Defaults to false.
!  *     * While the default settings of exclude_from_search, publicly_queryable, show_ui, and show_in_nav_menus are
!  *       inherited from public, each does not rely on this relationship and controls a very specific intention.
!  * - exclude_from_search - Whether to exclude posts with this post type from front end search results.
!  *     * If not set, the the opposite of public's current value is used.
!  * - publicly_queryable - Whether queries can be performed on the front end for the post type as part of parse_request().
!  *     * ?post_type={post_type_key}
!  *     * ?{post_type_key}={single_post_slug}
!  *     * ?{post_type_query_var}={single_post_slug}
!  *     * If not set, the default is inherited from public.
!  * - show_ui - Whether to generate a default UI for managing this post type in the admin.
!  *     * If not set, the default is inherited from public.
!  * - show_in_nav_menus - Makes this post type available for selection in navigation menus.
!  *     * If not set, the default is inherited from public.
!  * - show_in_menu - Where to show the post type in the admin menu.
!  *     * If true, the post type is shown in its own top level menu.
!  *     * If false, no menu is shown
!  *     * If a string of an existing top level menu (eg. 'tools.php' or 'edit.php?post_type=page'), the post type will
!  *       be placed as a sub menu of that.
!  *     * show_ui must be true.
!  *     * If not set, the default is inherited from show_ui
!  * - show_in_admin_bar - Makes this post type available via the admin bar.
!  *     * If not set, the default is inherited from show_in_menu
!  * - menu_position - The position in the menu order the post type should appear.
!  *     * show_in_menu must be true
!  *     * Defaults to null, which places it at the bottom of its area.
   * - menu_icon - The url to the icon to be used for this menu. Defaults to use the posts icon.
   * - capability_type - The string to use to build the read, edit, and delete capabilities. Defaults to 'post'.
!  *     * May be passed as an array to allow for alternative plurals when using this argument as a base to construct the
!  *       capabilities, e.g. array('story', 'stories').
!  * - capabilities - Array of capabilities for this post type.
!  *     * By default the capability_type is used as a base to construct capabilities.
!  *     * You can see accepted values in {@link get_post_type_capabilities()}.
   * - map_meta_cap - Whether to use the internal default meta capability handling. Defaults to false.
!  * - hierarchical - Whether the post type is hierarchical (e.g. page). Defaults to false.
!  * - supports - An alias for calling add_post_type_support() directly. Defaults to title and editor.
!  *     * See {@link add_post_type_support()} for documentation.
   * - register_meta_box_cb - Provide a callback function that will be called when setting up the
!  *     meta boxes for the edit form. Do remove_meta_box() and add_meta_box() calls in the callback.
   * - taxonomies - An array of taxonomy identifiers that will be registered for the post type.
!  *     * Default is no taxonomies.
!  *     * Taxonomies can be registered later with register_taxonomy() or register_taxonomy_for_object_type().
!  * - has_archive - True to enable post type archives. Default is false.
!  *     * Will generate the proper rewrite rules if rewrite is enabled.
!  * - rewrite - Triggers the handling of rewrites for this post type. Defaults to true, using $post_type as slug.
!  *     * To prevent rewrite, set to false.
!  *     * To specify rewrite rules, an array can be passed with any of these keys
!  *         * 'slug' => string Customize the permastruct slug. Defaults to $post_type key
!  *         * 'with_front' => bool Should the permastruct be prepended with WP_Rewrite::$front. Defaults to true.
!  *         * 'feeds' => bool Should a feed permastruct be built for this post type. Inherits default from has_archive.
!  *         * 'pages' => bool Should the permastruct provide for pagination. Defaults to true.
!  *         * 'ep_mask' => const Assign an endpoint mask.
!  *             * If not specified and permalink_epmask is set, inherits from permalink_epmask.
!  *             * If not specified and permalink_epmask is not set, defaults to EP_PERMALINK
!  * - query_var - Sets the query_var key for this post type. Defaults to $post_type key
!  *     * If false, a post type cannot be loaded at ?{query_var}={post_slug}
!  *     * If specified as a string, the query ?{query_var_string}={post_slug} will be valid.
!  * - can_export - Allows this post type to be exported. Defaults to true.
!  * - delete_with_user - Whether to delete posts of this type when deleting a user.
!  *     * If true, posts of this type belonging to the user will be moved to trash when then user is deleted.
!  *     * If false, posts of this type belonging to the user will *not* be trashed or deleted.
!  *     * If not set (the default), posts are trashed if post_type_supports('author'). Otherwise posts are not trashed or deleted.
   * - _builtin - true if this post type is a native or "built-in" post_type. THIS IS FOR INTERNAL USE ONLY!
   * - _edit_link - URL segement to use for edit link of this post type. THIS IS FOR INTERNAL USE ONLY!
   *
   * @since 2.9.0
   * @uses $wp_post_types Inserts new post type object into the list
   *
!  * @param string $post_type Post type key, must not exceed 20 characters
!  * @param array|string $args See optional args description above.
   * @return object|WP_Error the registered post type object, or an error object
   */
! function register_post_type( $post_type, $args = array() ) {
  	global $wp_post_types, $wp_rewrite, $wp;
  
  	if ( !is_array($wp_post_types) )
***************
*** 924,931 ****
  		'public' => false, 'rewrite' => true, 'has_archive' => false, 'query_var' => true,
  		'supports' => array(), 'register_meta_box_cb' => null,
  		'taxonomies' => array(), 'show_ui' => null, 'menu_position' => null, 'menu_icon' => null,
! 		'permalink_epmask' => EP_PERMALINK, 'can_export' => true,
  		'show_in_nav_menus' => null, 'show_in_menu' => null, 'show_in_admin_bar' => null,
  	);
  	$args = wp_parse_args($args, $defaults);
  	$args = (object) $args;
--- 967,975 ----
  		'public' => false, 'rewrite' => true, 'has_archive' => false, 'query_var' => true,
  		'supports' => array(), 'register_meta_box_cb' => null,
  		'taxonomies' => array(), 'show_ui' => null, 'menu_position' => null, 'menu_icon' => null,
! 		'can_export' => true,
  		'show_in_nav_menus' => null, 'show_in_menu' => null, 'show_in_admin_bar' => null,
+ 		'delete_with_user' => null,
  	);
  	$args = wp_parse_args($args, $defaults);
  	$args = (object) $args;
***************
*** 952,958 ****
  	if ( null === $args->show_in_admin_bar )
  		$args->show_in_admin_bar = true === $args->show_in_menu;
  
! 	// Whether to show this type in nav-menus.php.  Defaults to the setting for public.
  	if ( null === $args->show_in_nav_menus )
  		$args->show_in_nav_menus = $args->public;
  
--- 996,1002 ----
  	if ( null === $args->show_in_admin_bar )
  		$args->show_in_admin_bar = true === $args->show_in_menu;
  
! 	// Whether to show this type in nav-menus.php. Defaults to the setting for public.
  	if ( null === $args->show_in_nav_menus )
  		$args->show_in_nav_menus = $args->public;
  
***************
*** 999,1009 ****
  			$args->rewrite['pages'] = true;
  		if ( ! isset( $args->rewrite['feeds'] ) || ! $args->has_archive )
  			$args->rewrite['feeds'] = (bool) $args->has_archive;
  
  		if ( $args->hierarchical )
! 			$wp_rewrite->add_rewrite_tag("%$post_type%", '(.+?)', $args->query_var ? "{$args->query_var}=" : "post_type=$post_type&name=");
  		else
! 			$wp_rewrite->add_rewrite_tag("%$post_type%", '([^/]+)', $args->query_var ? "{$args->query_var}=" : "post_type=$post_type&name=");
  
  		if ( $args->has_archive ) {
  			$archive_slug = $args->has_archive === true ? $args->rewrite['slug'] : $args->has_archive;
--- 1043,1059 ----
  			$args->rewrite['pages'] = true;
  		if ( ! isset( $args->rewrite['feeds'] ) || ! $args->has_archive )
  			$args->rewrite['feeds'] = (bool) $args->has_archive;
+ 		if ( ! isset( $args->rewrite['ep_mask'] ) ) {
+ 			if ( isset( $args->permalink_epmask ) )
+ 				$args->rewrite['ep_mask'] = $args->permalink_epmask;
+ 			else
+ 				$args->rewrite['ep_mask'] = EP_PERMALINK;
+ 		}
  
  		if ( $args->hierarchical )
! 			add_rewrite_tag("%$post_type%", '(.+?)', $args->query_var ? "{$args->query_var}=" : "post_type=$post_type&name=");
  		else
! 			add_rewrite_tag("%$post_type%", '([^/]+)', $args->query_var ? "{$args->query_var}=" : "post_type=$post_type&name=");
  
  		if ( $args->has_archive ) {
  			$archive_slug = $args->has_archive === true ? $args->rewrite['slug'] : $args->has_archive;
***************
*** 1012,1028 ****
  			else
  				$archive_slug = $wp_rewrite->root . $archive_slug;
  
! 			$wp_rewrite->add_rule( "{$archive_slug}/?$", "index.php?post_type=$post_type", 'top' );
  			if ( $args->rewrite['feeds'] && $wp_rewrite->feeds ) {
  				$feeds = '(' . trim( implode( '|', $wp_rewrite->feeds ) ) . ')';
! 				$wp_rewrite->add_rule( "{$archive_slug}/feed/$feeds/?$", "index.php?post_type=$post_type" . '&feed=$matches[1]', 'top' );
! 				$wp_rewrite->add_rule( "{$archive_slug}/$feeds/?$", "index.php?post_type=$post_type" . '&feed=$matches[1]', 'top' );
  			}
  			if ( $args->rewrite['pages'] )
! 				$wp_rewrite->add_rule( "{$archive_slug}/{$wp_rewrite->pagination_base}/([0-9]{1,})/?$", "index.php?post_type=$post_type" . '&paged=$matches[1]', 'top' );
  		}
  
! 		$wp_rewrite->add_permastruct($post_type, "{$args->rewrite['slug']}/%$post_type%", $args->rewrite['with_front'], $args->permalink_epmask);
  	}
  
  	if ( $args->register_meta_box_cb )
--- 1062,1078 ----
  			else
  				$archive_slug = $wp_rewrite->root . $archive_slug;
  
! 			add_rewrite_rule( "{$archive_slug}/?$", "index.php?post_type=$post_type", 'top' );
  			if ( $args->rewrite['feeds'] && $wp_rewrite->feeds ) {
  				$feeds = '(' . trim( implode( '|', $wp_rewrite->feeds ) ) . ')';
! 				add_rewrite_rule( "{$archive_slug}/feed/$feeds/?$", "index.php?post_type=$post_type" . '&feed=$matches[1]', 'top' );
! 				add_rewrite_rule( "{$archive_slug}/$feeds/?$", "index.php?post_type=$post_type" . '&feed=$matches[1]', 'top' );
  			}
  			if ( $args->rewrite['pages'] )
! 				add_rewrite_rule( "{$archive_slug}/{$wp_rewrite->pagination_base}/([0-9]{1,})/?$", "index.php?post_type=$post_type" . '&paged=$matches[1]', 'top' );
  		}
  
! 		add_permastruct( $post_type, "{$args->rewrite['slug']}/%$post_type%", $args->rewrite );
  	}
  
  	if ( $args->register_meta_box_cb )
***************
*** 1070,1076 ****
   *   behave like edit_posts.
   * - publish_posts - Controls publishing objects of this post type.
   * - read_private_posts - Controls whether private objects can be read.
! 
   * These four primitive capabilities are checked in core in various locations.
   * There are also seven other primitive capabilities which are not referenced
   * directly in core, except in map_meta_cap(), which takes the three aforementioned
--- 1120,1126 ----
   *   behave like edit_posts.
   * - publish_posts - Controls publishing objects of this post type.
   * - read_private_posts - Controls whether private objects can be read.
!  *
   * These four primitive capabilities are checked in core in various locations.
   * There are also seven other primitive capabilities which are not referenced
   * directly in core, except in map_meta_cap(), which takes the three aforementioned
***************
*** 1289,1294 ****
--- 1339,1361 ----
  }
  
  /**
+  * Get all the post type features
+  *
+  * @since 3.4.0
+  * @param string $post_type The post type
+  * @return array
+  */
+ 
+ function get_all_post_type_supports( $post_type ) {
+ 	global $_wp_post_type_features;
+ 
+ 	if ( isset( $_wp_post_type_features[$post_type] ) )
+ 		return $_wp_post_type_features[$post_type];
+ 
+ 	return array();
+ }
+ 
+ /**
   * Checks a post type's support for a given feature
   *
   * @since 3.0.0
***************
*** 1331,1342 ****
  	global $wpdb;
  
  	$post_type = sanitize_post_field('post_type', $post_type, $post_id, 'db');
! 	$return = $wpdb->update($wpdb->posts, array('post_type' => $post_type), array('ID' => $post_id) );
  
! 	if ( 'page' == $post_type )
! 		clean_page_cache($post_id);
! 	else
! 		clean_post_cache($post_id);
  
  	return $return;
  }
--- 1398,1406 ----
  	global $wpdb;
  
  	$post_type = sanitize_post_field('post_type', $post_type, $post_id, 'db');
! 	$return = $wpdb->update( $wpdb->posts, array('post_type' => $post_type), array('ID' => $post_id) );
  
! 	clean_post_cache( $post_id );
  
  	return $return;
  }
***************
*** 1457,1468 ****
   * @link http://codex.wordpress.org/Function_Reference/get_post_meta
   *
   * @param int $post_id Post ID.
!  * @param string $key The meta key to retrieve.
   * @param bool $single Whether to return a single value.
   * @return mixed Will be an array if $single is false. Will be value of meta data field if $single
   *  is true.
   */
! function get_post_meta($post_id, $key, $single = false) {
  	return get_metadata('post', $post_id, $key, $single);
  }
  
--- 1521,1532 ----
   * @link http://codex.wordpress.org/Function_Reference/get_post_meta
   *
   * @param int $post_id Post ID.
!  * @param string $key Optional. The meta key to retrieve. By default, returns data for all keys.
   * @param bool $single Whether to return a single value.
   * @return mixed Will be an array if $single is false. Will be value of meta data field if $single
   *  is true.
   */
! function get_post_meta($post_id, $key = '', $single = false) {
  	return get_metadata('post', $post_id, $key, $single);
  }
  
***************
*** 1508,1523 ****
  /**
   * Retrieve post meta fields, based on post ID.
   *
!  * The post meta fields are retrieved from the cache, so the function is
!  * optimized to be called more than once. It also applies to the functions, that
!  * use this function.
   *
   * @since 1.2.0
   * @link http://codex.wordpress.org/Function_Reference/get_post_custom
   *
!  * @uses $id Current Loop Post ID
!  *
!  * @param int $post_id post ID
   * @return array
   */
  function get_post_custom( $post_id = 0 ) {
--- 1572,1584 ----
  /**
   * Retrieve post meta fields, based on post ID.
   *
!  * The post meta fields are retrieved from the cache where possible,
!  * so the function is optimized to be called more than once.
   *
   * @since 1.2.0
   * @link http://codex.wordpress.org/Function_Reference/get_post_custom
   *
!  * @param int $post_id Post ID.
   * @return array
   */
  function get_post_custom( $post_id = 0 ) {
***************
*** 1526,1535 ****
  	if ( ! $post_id )
  		$post_id = get_the_ID();
  
! 	if ( ! wp_cache_get( $post_id, 'post_meta' ) )
! 		update_postmeta_cache( $post_id );
! 
! 	return wp_cache_get( $post_id, 'post_meta' );
  }
  
  /**
--- 1586,1592 ----
  	if ( ! $post_id )
  		$post_id = get_the_ID();
  
! 	return get_post_meta( $post_id );
  }
  
  /**
***************
*** 1964,1970 ****
   * @return mixed False on failure
   */
  function wp_delete_post( $postid = 0, $force_delete = false ) {
! 	global $wpdb, $wp_rewrite;
  
  	if ( !$post = $wpdb->get_row($wpdb->prepare("SELECT * FROM $wpdb->posts WHERE ID = %d", $postid)) )
  		return $post;
--- 2020,2026 ----
   * @return mixed False on failure
   */
  function wp_delete_post( $postid = 0, $force_delete = false ) {
! 	global $wpdb;
  
  	if ( !$post = $wpdb->get_row($wpdb->prepare("SELECT * FROM $wpdb->posts WHERE ID = %d", $postid)) )
  		return $post;
***************
*** 1985,1990 ****
--- 2041,2054 ----
  	$parent_data = array( 'post_parent' => $post->post_parent );
  	$parent_where = array( 'post_parent' => $postid );
  
+ 	if ( is_post_type_hierarchical( $post->post_type ) ) {
+ 		// Point children of this page to its parent, also clean the cache of affected children
+ 		$children_query = $wpdb->prepare( "SELECT * FROM $wpdb->posts WHERE post_parent = %d AND post_type = %s", $postid, $post->post_type );
+ 		$children = $wpdb->get_results( $children_query );
+ 
+ 		$wpdb->update( $wpdb->posts, $parent_data, $parent_where + array( 'post_type' => $post->post_type ) );
+ 	}
+ 
  	if ( 'page' == $post->post_type) {
  	 	// if the page is defined in option page_on_front or post_for_posts,
  		// adjust the corresponding options
***************
*** 1995,2013 ****
  		if ( get_option('page_for_posts') == $postid ) {
  			delete_option('page_for_posts');
  		}
- 
- 		// Point children of this page to its parent, also clean the cache of affected children
- 		$children_query = $wpdb->prepare("SELECT * FROM $wpdb->posts WHERE post_parent = %d AND post_type='page'", $postid);
- 		$children = $wpdb->get_results($children_query);
- 
- 		$wpdb->update( $wpdb->posts, $parent_data, $parent_where + array( 'post_type' => 'page' ) );
  	} else {
  		unstick_post($postid);
  	}
  
! 	// Do raw query.  wp_get_post_revisions() is filtered
  	$revision_ids = $wpdb->get_col( $wpdb->prepare( "SELECT ID FROM $wpdb->posts WHERE post_parent = %d AND post_type = 'revision'", $postid ) );
! 	// Use wp_delete_post (via wp_delete_post_revision) again.  Ensures any meta/misplaced data gets cleaned up.
  	foreach ( $revision_ids as $revision_id )
  		wp_delete_post_revision( $revision_id );
  
--- 2059,2071 ----
  		if ( get_option('page_for_posts') == $postid ) {
  			delete_option('page_for_posts');
  		}
  	} else {
  		unstick_post($postid);
  	}
  
! 	// Do raw query. wp_get_post_revisions() is filtered
  	$revision_ids = $wpdb->get_col( $wpdb->prepare( "SELECT ID FROM $wpdb->posts WHERE post_parent = %d AND post_type = 'revision'", $postid ) );
! 	// Use wp_delete_post (via wp_delete_post_revision) again. Ensures any meta/misplaced data gets cleaned up.
  	foreach ( $revision_ids as $revision_id )
  		wp_delete_post_revision( $revision_id );
  
